// PrivIoXP.h - header file for PrivIoXP driver

#define PPORT_DATA_OFFSET 0
#define PPORT_STATUS_OFFSET 1
#define PPORT_CONTROL_OFFSET 2
#define PPORT_REGISTER_SPAN 3

typedef struct _DEVICE_EXTENSION {
    PDEVICE_OBJECT DeviceObject;
    PDEVICE_OBJECT PortDeviceObject;
    PIRP CurrentIrp;
    LONG OpenCount;
    LIST_ENTRY WorkQueue;
    PHYSICAL_ADDRESS OriginalController;
    PUCHAR Controller;
    ULONG SpanOfController;
    PVOID FreePortContext;
    PPARALLEL_FREE_ROUTINE FreePort;
    BOOLEAN CreatedSymbolicLink;
    UNICODE_STRING SymbolicLinkName;
} DEVICE_EXTENSION, *PDEVICE_EXTENSION;

NTSTATUS
DriverEntry (
    IN  PDRIVER_OBJECT  DriverObject,
    IN  PUNICODE_STRING RegistryPath
    ) ;

NTSTATUS
PrivIoXPCreate(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS
PrivIoXPClose (
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    ) ;

//NTSTATUS
//PrivIoXPWrite (
//    IN  PDEVICE_OBJECT  DeviceObject,
//    IN  PIRP            Irp
//    ) ;

NTSTATUS
PrivIoXPIOCtl (
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp                
    );

//NTSTATUS
//PrivIoXPAllocComplete (
//    IN  PDEVICE_OBJECT  DeviceObject,
//    IN  PIRP            Irp,
//    IN  PVOID           Extension
//    ) ;


NTSTATUS
PrivIoXPRead(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

//VOID
//PrivIoXPAllocPort (
//    IN  PDEVICE_EXTENSION  Extension
//    ) ;

//NTSTATUS
//PrivIoXPReadCompletionRoutine (
//    IN  PDEVICE_OBJECT  DeviceObject,
//    IN  PIRP            Irp,
//    IN  PVOID           Extension
//    ) ;

//VOID
//PrivIoXPAllocPortWithNext (
//    IN OUT PDEVICE_EXTENSION  Extension
//    ) ;

NTSTATUS
PrivIoXPCleanup(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

VOID
PrivIoXPUnload(
    IN  PDRIVER_OBJECT  DriverObject
    );

VOID
PrivIoXPCancel (
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    ) ;

